/**
 * add cordova plugin
 cordova plugin add cordova-plugin-network-information
 cordova plugin add cordova-plugin-geolocation --variable GEOLOCATION_USAGE_DESCRIPTION="亲,通过您的地理位置我们将为您推荐准确的内容"
 cordova plugin add https://github.com/gotojmp/cordova-plugin-native-ad.git
 *
 */
var AD_OPEN = 1; //广告显示总开关
var AD_APP = 'cn.baiwujiao.app'; //广告绑定APP
var AD_SPLASH = 1; //开屏广告开关
var AD_CHAPING = 1; //插屏广告开关
var AD_NATIVE = 1; //信息流广告开关
var AD_CHANNEL = '';//广告渠道，正式发布时留空

angular.module('Ad', ['ngCordova', 'cordovaHTTP'])

    .run(function($templateCache) {

        $templateCache.put('ad/kaiping.html', '<div class="ad-kaiping" ng-if="kaipingAd.click" ng-style="{\'width\':width+\'px\',\'height\':height+\'px\'}"> <div class="ad-kaiping-img" ng-click="clickAd(kaipingAd)" ng-style="{\'background-image\':\'url(\'+kaipingAd.show[0]+\')\'}"> </div> <button class="button ad-kaiping-close" ng-click="closeKaiping()">跳过</button> </div>');

        $templateCache.put('ad/banner.html', '<div class="ad-banner" ng-if="bannerAd.click" ng-hide="bannerAd.hide"> <div ng-click="hideAd(bannerAd)" class="ad-banner-close">关闭广告</div> <img class="ad-banner-img" ng-click="clickAd(bannerAd)" ng-src="{{ bannerAd.show[0] }}"> </div>');

        $templateCache.put('ad/chaping.html', '<div class="ad-chaping" ng-if="chapingAd.click" ng-hide="chapingAd.hide"> <div> <div class="ad-chaping-close" ng-click="hideAd(chapingAd)">关闭广告</div> <img class="ad-chaping-img" ng-click="clickAd(chapingAd)" ng-src="{{ chapingAd.show[0] }}"> </div> </div>');

        $templateCache.put('ad/native.html', '<div class="ad-native" ng-if="nativeAd.click" ng-hide="nativeAd.hide"> <h2 class="ad-native-title" ng-click="clickAd(nativeAd)">{{nativeAd.title}}</h2> <div class="ad-native-single" ng-click="clickAd(nativeAd)" ng-if="nativeAd.show.length==1"><img class="ad-native-single-img" ng-src="{{nativeAd.show[0]}}"></div> <div class="ad-native-group" ng-click="clickAd(nativeAd)" ng-if="nativeAd.show.length>1"><img class="ad-native-group-img" ng-repeat="src in nativeAd.show" ng-src="{{src}}"></div> <div class="ad-native-close" ng-click="hideAd(nativeAd)"> <i class="icon ion-ios-close-empty"></i> </div> </div>');

    })

    .run(function ($rootScope, $timeout, Ad, Splash) {
        /** for ad start **/
        $rootScope.width = window.screen.width;
        $rootScope.height = window.screen.height;
        $rootScope.kaipingAd = {};
        $rootScope.bannerAd = {};
        $rootScope.chapingAd = {};
        $rootScope.nativeAd = {};
        $rootScope.clickAd = function (ad) {
            if (ad.clickReport.length > 0) {
                ad.clickReport.forEach(function (url) {
                    var img = new Image();
                    img.src = url;
                    img.style.width = '1px';
                    img.style.height = '1px';
                    img.style.display = 'none';
                    document.body.appendChild(img);
                    console.log(img, url)
                });
            }
            window.NativeAd.openUrl(ad.click, '_blank');
        };
        $rootScope.hideAd = function (ad) {
            ad.hide = true;
        };
        $rootScope.closeKaiping = function () {
            Splash.close();
        };
        window.loadKaipingAd = function () {
            Splash.check();
            $timeout(function () {
                window.cordova && AD_OPEN && AD_SPLASH && Ad.load('kaiping');
            }, 100);
        };
        window.loadBannerAd = function () {
            $timeout(function () {
                window.cordova && AD_OPEN && Ad.load('banner');
            }, 100);
        };
        window.loadChapingAd = function () {
            $timeout(function () {
                window.cordova && AD_OPEN && AD_CHAPING && Ad.load('chaping');
            }, 100);
        };
        window.loadNativeAd = function () {
            $timeout(function () {
                window.cordova && AD_OPEN && AD_NATIVE && Ad.load('native');
            }, 100);
        };
        /** for ad end **/
    })

    .factory('Splash', function ($rootScope, $cordovaSplashscreen, $timeout) {
        var closeSplashScreen = function () {
            $timeout(function () {
                $cordovaSplashscreen.hide();
            }, 300);
        };
        var _splash = {};
        _splash.closeTimer = null;
        _splash.check = function () {
            var showSplash = false;
            if (window.cordova) {
                showSplash = !!AD_SPLASH;
                if (!showSplash) {
                    closeSplashScreen();
                }
            }
            if (showSplash) {
                $rootScope.showSplash = true;
            } else {
                $rootScope.initMain = true;
            }
        };
        _splash.skip = function () {
            closeSplashScreen();
            if (AD_SPLASH) {
                $rootScope.showSplash = false;
                $rootScope.initMain = true;
            }
        };
        _splash.timerClose = function () {
            closeSplashScreen();
            _splash.closeTimer = setTimeout(function () {
                _splash.close();
            }, 5000);
        };
        _splash.close = function () {
            closeSplashScreen();
            _splash.closeTimer && clearTimeout(_splash.closeTimer);
            _splash.closeTimer = null;
            $timeout(function () {
                $rootScope.showSplash = false;
                window.kaipingAd && window.kaipingAd.close();
            }, 200);
            $timeout(function () {
                $rootScope.initMain = true;
            });
        };
        return _splash;
    })

    .factory('Ad', function($rootScope, $timeout, $cordovaDevice, cordovaHTTP, Splash) {
        var __ad = {};
        if (!AD_OPEN) return __ad;
        if (!window.cordova) return __ad;
        var app = AD_APP;
        var task = AD_CHANNEL;
        var device = $cordovaDevice.getDevice();
        device.mac = '02:00:00:00:00:00';
        if (device.platform == 'Android') {
            var uuid = function () {
                var s = [];
                var hexDigits = "0123456789abcdef";
                for (var i = 0; i < 36; i++) {
                    s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
                }
                s[14] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
                s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01
                s[8] = s[13] = s[18] = s[23] = "-";
                return s.join("");
            };
            var uid = cordova.plugins.uid;
            device.imei = uid.IMEI;
            device.imsi = uid.IMSI;
            if (uid.MAC) device.mac = uid.MAC;
            device.idfa = localStorage.getItem('android-adv-id');
            if (!device.idfa) {
                device.idfa = uuid();
                localStorage.setItem('android-adv-id', device.idfa);
            }
        }
        device.ua = window.navigator.userAgent;
        device.density = window.devicePixelRatio || 1;
        device.dpiw = device.density * window.screen.width;
        device.dpih = device.density * window.screen.height;
        device.geo = { lon: '', lat: '' };
        device.carrier = '';
        device.mcc = '';
        device.mnc = '';
        var getCarrier = function () {
            window.plugins.sim.getSimInfo(function (info) {
                device.carrier = info.carrierName;
                device.mcc = info.mcc;
                device.mnc = info.mnc;
            }, function (err) { });
        };
        var getPos = function (cb) {
            window.navigator.geolocation.getCurrentPosition(function (pos) {
                device.geo = { lon: pos.coords.longitude, lat: pos.coords.latitude };
                cb && cb();
            }, function () { cb && cb(); });
        };
        var getConnection = function () {
            device.nc = window.navigator.connection.type;
        };
        var analyzeAd = function (req, raw, cb) {
            var ad = window.AdAnalyzer ? window.AdAnalyzer.run(req, raw) : {};
            console.log(ad);
            cb && cb(ad);
        };
        var showAd = function (type, ad) {
            if (type == 'kaiping' && AD_SPLASH) {
                if (ad && (ad.html || ad.click)) {
                    Splash.timerClose();
                } else {
                    Splash.close();
                }
            }
            if (!ad) return;
            if (type == 'banner') {
                $rootScope.bannerAd = ad;
            } else if (type == 'kaiping') {
                if (AD_SPLASH) $rootScope.kaipingAd = ad;
            } else if (type == 'chaping') {
                if (AD_CHAPING) $rootScope.chapingAd = ad;
            } else if (type == 'native') {
                if (AD_NATIVE) $rootScope.nativeAd = ad;
            }
            if (ad.html) { //native show ad
                var w = window.screen.width;
                var h = parseInt(w * ad.h / ad.w);
                if (type == 'kaiping') {
                    if (window.kaipingAd) {
                        window.kaipingAd.close();
                    }
                    window.kaipingAd = window.NativeAd.open(ad.html, w, h, 'center', 'topRight');
                    window.kaipingAd.onClose = function () {
                        Splash.close();
                    };
                } else if (type == 'banner') {
                    if (window.bannerAd) {
                        window.bannerAd.close();
                    }
                    window.bannerAd = window.NativeAd.open(ad.html, w, h, 'bottom', ad.closeAt);
                } else if (type == 'chaping') {
                    if (window.chapingAd) {
                        window.chapingAd.close();
                    }
                    window.chapingAd = window.NativeAd.open(ad.html, w, h, 'bottom', ad.closeAt);
                }
            }
            if ((ad.html || ad.click) && ad.showReport.length > 0) {
                setTimeout(function () {
                    ad.showReport.forEach(function (url) {
                        var img = new Image();
                        img.src = url;
                        img.style.width = '1px';
                        img.style.height = '1px';
                        img.style.display = 'none';
                        document.body.appendChild(img);
                        console.log(img, url)
                    });
                }, 500);
            }
        };
        var getAd = function (req, cb) {
            if (req.method == 'GET') {
                cordovaHTTP.get(req.url, {}, req.headers||{}).then(function(response) {
                    try {
                        console.log(req.task, response.data);
                        var ret = JSON.parse(response.data);
                        analyzeAd(req, ret, cb);
                    } catch(e) {
                        console.log(e);
                        cb && cb(null);
                    }
                }, function(response) {
                    console.log(response);
                    cb && cb(null);
                });
            } else if (req.method == 'POST') {
                cordovaHTTP.post(req.url, req.data, req.headers||{'Content-Type':'application/json'}).then(function(response) {
                    try {
                        console.log(req.task, response.data);
                        var ret = JSON.parse(response.data);
                        analyzeAd(req, ret, cb);
                    } catch(e) {
                        cb && cb(null);
                    }
                }, function() {
                    cb && cb(null);
                });
            }
        };
        var getReq = function (type, cb) {
            console.log(device);
            cordovaHTTP.post('http://y.ad4.com.cn/ad-app-request', {
                app: app,
                task: task,
                device: device,
                type: type
            }, {'Content-Type':'application/json'}).then(function(response) {
                try {
                    var ret = JSON.parse(response.data);
                    cb && cb(ret);
                } catch(e) {
                    cb && cb(null);
                }
            }, function(err) {
                cb && cb(null);
            });
        };
        __ad.load = function (type) {
            type = type || 'kaiping';
            getReq(type, function (ret) {
                console.log('get req return', ret);
                if (!ret || ret.err) {
                    return Splash.skip();
                }
                var req = ret.msg.request;
                if (req && typeof req == 'object') {
                    var hasKaiping = false;
                    for (var type in req) {
                        if (type == 'kaiping') hasKaiping = true;
                        (function (type, req) {
                            console.log(type, req);
                            getAd(req, function (ad) {
                                showAd(type, ad);
                            });
                        })(type, req[type]);
                    }
                    if (!hasKaiping && AD_SPLASH) {
                        Splash.skip();
                    }
                } else {
                    Splash.skip();
                }
            });
        };
        getCarrier();
        getPos();
        getConnection();
        return __ad;
    });

!window.cordova && angular.module('cordovaHTTP',[]).factory('cordovaHTTP', function(){return {}});
