// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', ['ionic',  'ngSanitize', 'ngStorage', 'ngCordova', 'ms.route', 'ms.service', 'ms.directive', 'ms.controller', 'ms.constant', 'Ad'])

.config(function($ionicConfigProvider) {
  $ionicConfigProvider.tabs.position('bottom');
  $ionicConfigProvider.views.transition('none');
  /*$ionicConfigProvider.views.maxCache(10);
  /*$ionicConfigProvider.views.forwardCache(false);*/
})

.run(function($ionicPlatform, $rootScope, $ionicHistory, $cordovaSQLite, $location, $state, $timeout) {
        $ionicPlatform.ready(function() {
            console.log('设备就绪');
            if (window.cordova && window.cordova.plugins.Keyboard) {
                // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                // for form inputs)
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);

                // Don't remove this line unless you know what you are doing. It stops the viewport
                // from snapping when text inputs are focused. Ionic handles this internally for
                // a much nicer keyboard experience.
                cordova.plugins.Keyboard.disableScroll(true);
            }
            if (window.StatusBar) {
                StatusBar.styleDefault();
            }
            $rootScope.wxInstalled = false;
            $timeout(function () {
                if (window.Wechat) {
                    Wechat.isInstalled(function (installed) {
                        $rootScope.wxInstalled = !!installed;
                    });
                }
            }, 500);
            loadKaipingAd();
        });

        $ionicPlatform.registerBackButtonAction(function(e) {
            var rootStates = ['focus', 'journal', 'user'];
            console.log($location.path());
            if ($rootScope.backButtonPressedOnceToExit) {
                ionic.Platform.exitApp();
            } else if (rootStates.indexOf($ionicHistory.currentView().stateName) != -1) {
                $ionicHistory.nextViewOptions({
                    historyRoot: true
                });
                $state.go('home');
            } else if ($ionicHistory.backView()) {
                $rootScope.$ionicGoBack();
            } else {
                $rootScope.backButtonPressedOnceToExit = true;
                window.plugins.toast.showShortBottom(
                    "再按一次退出系统",
                    function(a) {},
                    function(b) {}
                );
                setTimeout(function() {
                    $rootScope.backButtonPressedOnceToExit = false;
                }, 2000);
            }
            e.preventDefault();
            return false;
        }, 101);

    })

.run(function($rootScope, $state, $ionicHistory, AuthService, ModalService) {
  $rootScope.$on('$stateChangeStart', function(event, next, nextParams, from) {
    var privateStates = ['user-focus', 'user-info', 'user-heart'];
    if (privateStates.indexOf(next.name) !== -1) {
      if (! AuthService.isAuthenticated()) {
        event.preventDefault();
        ModalService.loginModal.open($rootScope.login);
      }
    }

  })
})
angular.element(document).ready(function () {
    setTimeout(function () {
        angular.bootstrap(document, ['starter']);
    }, 100);
});
