angular
  .module('ms.directive', [])
  .directive('hideTabs', function($rootScope) {
    return {
      restrict: 'A',
      link: function($scope, $el) {
        $scope.shouldHideTabs = true;
        if ($rootScope.hideTabs) {
          console.log('ok');
          $scope.shouldHideTabs = false;
        }
        console.log('init + ' + $rootScope.hideTabs + '!');
        $rootScope.hideTabs = 'tabs-item-hide';
        $scope.$on('$destroy', function() {
          console.log('destroy');
          if ($scope.shouldHideTabs)
            $rootScope.hideTabs = '';
        });
      }
    };
  })

  .directive('focusMe', function($timeout) {
    return {
      link: function(scope, element, attrs) {
        $timeout(function() {
          element[0].focus();
        }, 0);
      }
    };
  })

  .filter('relativeTime', function() {
    return function(date) {
      if (! date) return null;
      var now = new Date().getTime();
      var diff = now - new Date(date).getTime(); // milliseconds
      var suffix = '';
      var result = 0;
      if (diff < 3600 * 1000) {
        result = parseInt(diff / 1000 / 60);
        suffix = '分钟前';
      } else if (diff < 86400 * 1000) {
        result = parseInt(diff / 1000 / 3600);
        suffix = '小时前';
      } else if (diff < 86400 * 1000 * 3) {
        result = parseInt(diff / 1000 / 86400);
        suffix = '天前';
      } else {
        result = date.split(' ')[0];
      }
      return result + suffix;
    }
  })

  .filter('imagePath', function(API_ENDPOINT) {
    return function(url) {
      return API_ENDPOINT.IMAGE_FILE_URL + url;
    }
  })

  .filter('contentImagePath', function(API_ENDPOINT) {
    return function(url) {
      if (! url) return;
      url = url.replace(/(src=")(?!http:\/\/)(.*?)"/g, '$1' + API_ENDPOINT.IMAGE_FILE_URL + '$2"');
      return url;
    }
  })

  .filter('hrefToJS', function ($sce, $sanitize) {
    return function (text) {
        var regex = /href="([\S]+)"/g;
        var newString = $sanitize(text).replace(regex, "onClick=\"window.open('$1', '_blank', 'location=yes')\"");
        return $sce.trustAsHtml(newString);
    }
  })

  .directive('compile', ['$compile', function ($compile) {
    return function(scope, element, attrs) {
        scope.$watch(
            function(scope) {
                // watch the 'compile' expression for changes
                return scope.$eval(attrs.compile);
            },
            function(value) {
                // when the 'compile' expression changes
                // assign it into the current DOM
                element.html(value);

                // compile the new DOM and link it to the current
                // scope.
                // NOTE: we only compile .childNodes so that
                // we don't get into infinite loop compiling ourselves
                $compile(element.contents())(scope);
            }
        );
    };
}])
