angular
.module('ms.route', [])
.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

  // 文章详细页 - 参数：文章ID
  .state('detail-news', {
    url: '/detail_news/:id',
    templateUrl: 'views/detail/news.html',
    controller: 'DetailNewsCtrl'
  })

  // 公众号详细 - 参数：公众号ID
  .state('detail-journal', {
    url: '/detail_journal/:id',
    templateUrl: 'views/detail/journal.html',
    controller: 'DetailJournalCtrl'
  })

  .state('tabs', {
    url: '/tabs',
    abstract: true,
    templateUrl: 'views/tabs/main.html'
  })

  .state('home', {
    url: '/home',
    parent: 'tabs',
    views: {
      'tab-content': {
        templateUrl: 'views/tab_home/main.html',
        controller: 'HomeCtrl'
      }
    }
  })

  .state('discover', {
    url: '/discover',
    parent: 'tabs',
    views: {
      'tab-content': {
        templateUrl: 'views/tab_discover/main.html',
        controller: 'DiscoverCtrl'
      }
    }
  })

  // 小刊->专题结果
  .state('topic', {
    url: '/topic/:index',
    params: {
      keyword: ''
    },
    templateUrl: 'views/tab_discover/topic/main.html',
    controller: 'TopicCtrl'
  })

  .state('discover-detail', {
    url: '/discover_detail/:id',
    templateUrl: 'views/tab_discover/detail/main.html',
    controller: 'DiscoverDetailCtrl'
  })
  
  .state('search', {
    url: '/search',
    templateUrl: 'views/tab_discover/search/main.html',
    controller: 'SearchCtrl'
  })

  .state('journal', {
    url: '/journal',
    parent: 'tabs',
    views: {
      'tab-content': {
        templateUrl: 'views/tab_journal/main.html',
        controller: 'JournalCtrl'
      }
    }
  })

  .state('category-detail', {
    url: '/category_detail/:id',
    templateUrl: 'views/tab_journal/category/main.html',
    controller: 'JournalCategoryCtrl'
  })

  .state('user', {
    url: '/user',
    parent: 'tabs',
    views: {
      'tab-content': {
        templateUrl: 'views/tab_user/main.html',
        controller: 'UserCtrl'
      }
    }
  })

  .state('user-focus', {
    url: '/user_focus',
    templateUrl: 'views/tab_user/focus/main.html',
    controller: 'UserFocusCtrl'
  })

  .state('user-heart', {
    url: '/user_heart',
    templateUrl: 'views/tab_user/heart/main.html',
    controller: 'UserHeartNewsCtrl'
  })

  .state('user-info', {
    url: '/info',
    templateUrl: 'views/tab_user/info/main.html',
    controller: 'UserInfoCtrl'
  })

  .state('about', {
    url: '/about',
    templateUrl: 'views/tab_user/about/main.html'
  })

  $urlRouterProvider.otherwise('/tabs/home');
})
