angular
  .module('ms.controller')
  .controller('DetailJournalCtrl', function($scope, $rootScope, $location, $stateParams, $ionicHistory, $ionicLoading, $ionicScrollDelegate, $timeout, ApiService) {
    loadNativeAd(); //for ad
    $scope.data = {
      id: $stateParams.id,
      news: [],
      journal: {},

      totalPage: 1,
      pageNo: 1,

      scrollPos: 0
    };

    $scope.goBack = function() {
      //$rootScope.$ionicGoBack();
      $ionicHistory.goBack();
    }

    $scope.getScrollPosition = function() {
      $timeout(function() {
        $scope.data.scrollPos = $ionicScrollDelegate.getScrollPosition().top;
      });
    }

    $scope.loadMoreNews = function() {
      ApiService
        .loadNewsByJournal({
          journalID: $scope.data.id,
          pageNo: $scope.data.pageNo + 1
        })
        .then(function(response) {
          $scope.data.totalPage = response.data.totalPage;
          $scope.data.pageNo = response.data.pageNo;

          for (var i = 0; i < response.data.news.length; i++) {
            $scope.data.news.push(response.data.news[i]);
          }
        })
        .catch(function(error){
        })
        .finally(function() {
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
    }

    init();

    function init() {
      loadJournal();
      loadNews();
    }

    function loadJournal() {
      ApiService
        .loadJournal({
          journalID: $scope.data.id
        })
        .then(function(response) {
          $scope.data.journal = response.data.journal;
        })
        .catch(function(error) {
        })
        .finally(function() {
        })
    }

    function loadNews() {
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
      ApiService
        .loadNewsByJournal({
          journalID: $scope.data.id,
          pageNo: 1
        })
        .then(function(response) {
          $scope.data.totalPage = response.data.totalPage;
          $scope.data.pageNo = response.data.pageNo;
          $scope.data.news = response.data.news;
        })
        .catch(function(error){})
        .finally(function() {
          $ionicLoading.hide();
        })
    }
  })

  .controller('DetailNewsCtrl', function($scope, $state, $rootScope, $timeout, $stateParams, $ionicHistory, $ionicLoading, $ionicScrollDelegate, ApiService, API_ENDPOINT) {

    $scope.data = {
      id: $stateParams.id, // 文章ID
      journal: {},
      topNews: {},
      recentNews: [],

      totalPage: 1,
      pageNo: 0
    };

    $scope.$on('LIKE_CLICKED', function(event, data) {
      if ($scope.data.topNews.Nid == data.newsID) {
        if (data.addFlag) {
          $scope.data.topNews.likes_count++;
        } else {
          $scope.data.topNews.likes_count--;
        }
      }
    })

    $scope.goBack = function() {
      //$rootScope.$ionicGoBack();
      $ionicHistory.goBack();
    }

    $scope.loadMoreRecentNews = function() {
      ApiService
        .loadNewsByJournal({
          journalID: $scope.data.journal.JID,
          pageNo: $scope.data.pageNo + 1
        })
        .then(function(response) {
          $scope.data.totalPage = response.data.totalPage;
          $scope.data.pageNo = response.data.pageNo;
          for (var i = 0; i < response.data.news.length; i++) {
            $scope.data.recentNews.push(response.data.news[i]);
          }
        })
        .catch(function(error) {
        })
        .finally(function() {
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
    }

    init();

    function init() {
      loadNews();
    }

    function loadNews() {
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
      ApiService
        .loadNews({
          newsID: $scope.data.id
        })
        .then(function(response) {
          if (response.data) {
            $scope.data.topNews = response.data.news;
            $scope.data.journal = response.data.journal;

            loadRecentNews();
          }
        })
        .catch(function(error) {
        })
        .finally(function() {
          $ionicLoading.hide();
        })
    }

    function loadRecentNews() {
      ApiService
        .loadNewsByJournal({
          journalID: $scope.data.journal.JID,
          pageNo: 1
        })
        .then(function(response) {
          $scope.data.totalPage = response.data.totalPage;
          $scope.data.pageNo = response.data.pageNo;
          $scope.data.recentNews = response.data.news;
        })
        .catch(function(error) {
        })
        .finally(function() {
        })
    }
  })
