angular
.module('ms.controller')
.controller('DiscoverCtrl', function($scope, $state, $ionicHistory, $ionicLoading, LocalService, ApiService) {
  $scope.data = {
    categories: LocalService.categories(),
    latestNews: [],

    categoryNo: 1,

    tmpData: []
  };

  $scope.doRefresh = function() {
    loadLatestNews(true);
  }

  $scope.loadMore = function() {
    var category = $scope.data.categories[$scope.data.categoryNo - 1];
    ApiService
      .loadAllTopNews({
        pageNo: 1,
        categoryID: category.sid
      })
      .then(function(response) {
        var block = {
          category: category,
          news: []
        };
        for (var i = 0; i < response.data.news.length && i < 3; i++) {
          block.news.push(response.data.news[i]);
        }
        $scope.data.tmpData.push(block);
        $scope.data.categoryNo ++;
      })
      .catch(function(error) {
      })
      .finally(function() {
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }

  init();

  function init() {
    loadLatestNews(false);
  }

  function loadLatestNews(isRefreshing) {
    if (! isRefreshing) {
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
    }
    ApiService
      .loadLatestNews()
      .then(function(response) {
        $scope.data.latestNews.push(response.data.news);
      })
      .catch(function(error) {
      })
      .finally(function() {
        if (! isRefreshing) {
          $ionicLoading.hide();
        } else {
          $scope.$broadcast('scroll.refreshComplete');
        }
      })
  }
})
