angular
.module('ms.controller')
.controller('DiscoverDetailCtrl', function($scope, $rootScope, $state, $ionicHistory, $timeout, $location, $ionicLoading, $stateParams, $ionicScrollDelegate, LocalService, ApiService) {
  $scope.data = {
    categoryID: $stateParams.id,
    categoryName: LocalService.categoryName($stateParams.id),
    topNews: [],

    totalPage: 1,
    pageNo: 1
  };

  $scope.goBack = function() {
    //$rootScope.$ionicGoBack();
    $ionicHistory.goBack();
  }

  $scope.doRefresh = function() {
    init(true);
  };

  $scope.loadMore = function() {
    ApiService
      .loadAllTopNews({
        pageNo: $scope.data.pageNo + 1,
        categoryID: $scope.data.categoryID
      })
      .then(function(response) {
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;

        for (var i = 0; i < response.data.news.length; i++) {
          var topNews = response.data.news[i];
          $scope.data.topNews.push(topNews);
        }
      })
      .catch(function(response) {
      })
      .finally(function() {
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }

  init(false);

  function init(isRefreshing) {
    if (! isRefreshing) {
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
    }
    ApiService
      .loadAllTopNews({
        pageNo: 1,
        categoryID: $scope.data.categoryID
      })
      .then(function(response) {
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;
        $scope.data.topNews = response.data.news;
      })
      .catch(function(response) {
      })
      .finally(function() {
        if (! isRefreshing) {
          $ionicLoading.hide();
        } else {
          $scope.$broadcast('scroll.refreshComplete');
        }
      })
  }
})
