angular
.module('ms.controller')
.controller('TopicCtrl', function($scope, $rootScope, $state, $ionicHistory, $timeout, $location, $ionicLoading, $stateParams, $ionicScrollDelegate, LocalService, ApiService) {
   $scope.data = {
    filterIndex: 1,
    keyword: $stateParams.keyword,
    topicIndex: $stateParams.index,
    searchResults: {
      news: [],
      journals: []
    },
    searchFinished: true,

    journalTotalPage: 2,
    journalPageNo: 1,
    newsTotalPage: 2,
    newsPageNo: 1,
    name: true,

    firstFilterChange: true
  };


  $scope.doRefresh = function() {
    init();
    $scope.$broadcast('scroll.refreshComplete');
  };

  $scope.loadMoreSearchNews = function() {
    $scope.data.searchFinished = false;
    var keyword = key($scope.data.topicIndex);
    ApiService
      .loadSearchNews({
        keyword: keyword,
        pageNo: $scope.data.newsPageNo + 1
      })
      .then(function(response) {
        $scope.data.newsTotalPage = response.data.totalPage;
        $scope.data.newsPageNo = response.data.pageNo;
        for (var i = 0; i < response.data.news.length; i++) {
          $scope.data.searchResults.news.push(response.data.news[i]);
        }
      })
      .catch(function(response) {
      })
      .finally(function(response) {
        $ionicLoading.hide();
        $scope.data.searchFinished = true;
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }

  init();


  function init() {
    $scope.data.searchFinished = false;
    var keyword = key($scope.data.topicIndex);
    $scope.data.name = keyword;
    if ($scope.data.filterIndex == 1) { // 文章
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
      ApiService
        .loadSearchNews({
          keyword: keyword,
          pageNo: 1
        })
        .then(function(response) {
          $scope.data.newsTotalPage = response.data.totalPage;
          $scope.data.newsPageNo = response.data.pageNo;
          $scope.data.searchResults.news = response.data.news;
        })
        .catch(function(response) {
        })
        .finally(function(response) {
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
          $ionicLoading.hide();
          $scope.data.searchFinished = true;
        })
    } else { // 小刊
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
      ApiService
        .loadSearchJournals({
          keyword: $scope.data.keyword,
          pageNo: 1
        })
        .then(function(response) {
          $scope.data.journalTotalPage = response.data.totalPage;
          $scope.data.journalPageNo = response.data.pageNo;
          $scope.data.searchResults.journals = response.data.journals;
        })
        .catch(function(response) {
        })
        .finally(function(response) {
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
          $ionicLoading.hide();
          $scope.data.searchFinished = true;
        })
    }
  }


  function key(data){
      if(data==0){
        return "美妆";
      }
  }


})
