angular
.module('ms.controller')
.controller('JournalCategoryCtrl', function($scope, $rootScope, $state, $ionicHistory, $timeout, $location, $ionicLoading, $stateParams, $ionicScrollDelegate, LocalService, ApiService) {
  $scope.data = {
    categoryID: $stateParams.id,
    categoryName: ($stateParams.id == 0) ? '最热' : LocalService.categoryName($stateParams.id),
    journals: [],

    totalPage: 1,
    pageNo: 1
  };

  $rootScope.$on('FOCUS_CLICKED', function(event, data) {
    for (var index = 0; index < $scope.data.journals.length; index++) {
      if ($scope.data.journals[index].JID == data.journalID)
        break;
    }

    if (index < $scope.data.journals.length) {
      if (data.addFlag) {
        $scope.data.journals[index].focuses_count ++;
      } else {
        $scope.data.journals[index].focuses_count --;
      }
    }
  });

  $scope.goBack = function() {
    //$rootScope.$ionicGoBack();
    $ionicHistory.goBack();
  }

  $scope.doRefresh = function() {
    init(true);
  };

  $scope.loadMoreJournals = function() {
    if ($scope.data.categoryID == 0) {
      ApiService
        .loadHotJournals({
          pageNo: $scope.data.pageNo + 1
        })
        .then(function(response) {
          $scope.data.totalPage = response.data.totalPage;
          $scope.data.pageNo = response.data.pageNo;

          for (var i = 0; i < response.data.journals.length; i++) {
            var journal = response.data.journals[i];
            $scope.data.journals.push(journal);
          }
        })
        .catch(function(response) {
        })
        .finally(function() {
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
    } else {
      ApiService
        .loadJournalsByCategory({
          categoryID: $scope.data.categoryID,
          pageNo: $scope.data.pageNo + 1
        })
        .then(function(response) {
          $scope.data.totalPage = response.data.totalPage;
          $scope.data.pageNo = response.data.pageNo;

          for (var i = 0; i < response.data.journals.length; i++) {
            $scope.data.journals.push(response.data.journals[i]);
          }
        })
        .catch(function(error) {
        })
        .finally(function() {
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
    }
  }

  init(false);

  function init(isRefreshing) {
    if (! isRefreshing) {
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
    }
    if ($scope.data.categoryID == 0) {
      ApiService
        .loadHotJournals({
          pageNo: 1
        })
        .then(function(response) {
          $scope.data.totalPage = response.data.totalPage;
          $scope.data.pageNo = response.data.pageNo;
          $scope.data.journals = response.data.journals;
        })
        .catch(function(response) {
        })
        .finally(function() {
          if (! isRefreshing) {
            $ionicLoading.hide();
          } else {
            $scope.$broadcast('scroll.refreshComplete');
          }
        })
    } else if ($scope.data.categoryID) {
      ApiService
        .loadJournalsByCategory({
          categoryID: $scope.data.categoryID,
          pageNo: 1
        })
        .then(function(response) {
          $scope.data.totalPage = response.data.totalPage;
          $scope.data.pageNo = response.data.pageNo;
          $scope.data.journals = response.data.journals;
        })
        .catch(function(error) {
        })
        .finally(function() {
          if (! isRefreshing) {
            $ionicLoading.hide();
          } else {
            $scope.$broadcast('scroll.refreshComplete');
          }
        })
    }
  }
})
