angular
.module('ms.controller')
.controller('JournalCtrl', function($scope, $rootScope, $state, $ionicLoading, LocalService, ApiService) {
  loadChapingAd(); //for ad
  $scope.data = {
    categories: LocalService.categories(),
    hotJournals: [],
    categoryNo: 1,
    tmpData: []
  };

  $rootScope.$on('FOCUS_CLICKED', function(event, data) {
    for (var index = 0; index < $scope.data.hotJournals.length; index++) {
      if ($scope.data.hotJournals[index].JID == data.journalID)
        break;
    }

    if (index < $scope.data.hotJournals.length) {
      if (data.addFlag) {
        $scope.data.hotJournals[index].focuses_count ++;
      } else {
        $scope.data.hotJournals[index].focuses_count --;
      }
    }

    var found = false;
    for (index = 0; index < $scope.data.tmpData.length && ! found; index++) {
      for (var i = 0; i < $scope.data.tmpData[index].journals.length && ! found; i++) {
        if ($scope.data.tmpData[index].journals[i].JID == data.journalID) {
          found = true;
          if (data.addFlag) {
            $scope.data.tmpData[index].journals[i].focuses_count ++;
          } else {
            $scope.data.tmpData[index].journals[i].focuses_count --;
          }
          break;
        }
      }
    }
  });

  $scope.doRefresh = function() {
    loadCategoryJournals(true);
  };

  $scope.loadMore = function() {
    var category = $scope.data.categories[$scope.data.categoryNo - 1];

    ApiService
      .loadJournalsByCategory({
        categoryID: category.sid,
        pageNo: 1
      })
      .then(function(response) {
        var block = {
          category: category,
          journals: []
        };
        for (var i = 0; i < response.data.journals.length; i++) {
          block.journals.push(response.data.journals[i]);
        }
        $scope.data.tmpData.push(block);
        $scope.data.categoryNo ++;
      })
      .catch(function(error) {
      })
      .finally(function() {
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }

  init();

  function init() {
    loadHotJournals();
    loadCategoryJournals(false);
  }

  function loadHotJournals() {
    ApiService
      .loadHotJournals({
        pageNo: 1
      })
      .then(function(response) {
        $scope.data.hotJournals = response.data.journals;
      })
      .catch(function(response) {
      })
      .finally(function() {
      })
  }

  function loadCategoryJournals(isRefreshing) {
    if (! isRefreshing) {
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
    } else {
      $scope.data.categoryNo = 1;
      $scope.data.tmpData = [];
    }

    var category = $scope.data.categories[$scope.data.categoryNo - 1];
    ApiService
      .loadJournalsByCategory({
        categoryID: category.sid,
        pageNo: 1
      })
      .then(function(response) {
        var block = {
          category: category,
          journals: []
        };
        for (var i = 0; i < response.data.journals.length; i++) {
          block.journals.push(response.data.journals[i]);
        }
        $scope.data.tmpData.push(block);
        $scope.data.categoryNo ++;
      })
      .catch(function(error) {
      })
      .finally(function() {
        if (! isRefreshing) {
          $ionicLoading.hide();
        } else {
          $scope.$broadcast('scroll.refreshComplete');
        }
      })
  }
})
