angular
.module('ms.controller')
.controller('UserCtrl', function($scope, $rootScope, $state, $timeout, $ionicHistory, $ionicModal, AuthService, ModalService, API_ENDPOINT) {
  $scope.data = {
    avatar: '',
    name: '',
    gender: '0',
    isAuthenticated: AuthService.isAuthenticated()
  };

  $rootScope.$on('PROFILE_UPDATED', function(event, data) {
    $scope.data.avatar = (data.avatar) ? (API_ENDPOINT.PUBLIC_FILE_URL + data.avatar)
                                       : ('img/3.png');

    $scope.data.name = data.name;
    $scope.data.gender = data.gender;
  });

  $scope.$on('LOGIN', function(event, data) {
    init();
  })

  $scope.login = function() {
    if (! AuthService.isAuthenticated()) {
      ModalService.loginModal.open($rootScope.login);
    }
  }

  $scope.logout = function() {
    AuthService.logout(function() {
      $ionicHistory.nextViewOptions({
        disableAnimate: true,
        historyRoot: true
      });
      $scope.data.isAuthenticated = false;
      $state.go('home');
    });
  }

  $scope.shareApp = function() {
    ModalService.shareModal.open(shareApp);
  }

  /*$scope.setOldToken = function() {
    var token = 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJuYW1lIjoiTGVvIiwiZ2VuZGVyIjowLCJhdmF0YXIiOiIiLCJzdWIiOjEsImlzcyI6Imh0dHA6XC9cLzE5Mi4xNjguMS4xMDRcL2F1dGhlbnRpY2F0ZSIsImlhdCI6MTQ4MTIzNDMzOSwiZXhwIjoxNDgxMjM3OTM5LCJuYmYiOjE0ODEyMzQzMzksImp0aSI6ImQ0NDY0M2E0NWEwOGZiNmFkNTlkZGE2ZDg0NWI2YzdhIn0.I38NpWgjxMXzx5dTr9PMxzWxlIDWDmh2MhhYf9OXYS0';
    AuthService.testOldToken(token);
    init();
  }*/

  init();

  function init() {
    if ($scope.data.isAuthenticated = AuthService.isAuthenticated()) {
      var user = AuthService.getTokenClaims();
      if (user.avatar.search("http") == 0) {
        $scope.data.avatar = user.avatar;
      } else if (user.avatar) {
        $scope.data.avatar = API_ENDPOINT.PUBLIC_FILE_URL + user.avatar;
      } else {
        $scope.data.avatar = 'img/3.png';
      }

      $scope.data.name = user.name;
      $scope.data.gender = user.gender;
    }
  }

  function shareApp(index) {
    var scene;
    if (index == 1) { // 朋友
       scene = Wechat.Scene.SESSION
    } else { // 朋友圈
       scene = Wechat.Scene.TIMELINE
    }
    Wechat.share({
      message: {
        title: '买手',
        description: '神奇买手',
        //thumb: API_ENDPOINT.IMAGE_FILE_URL,
        media: {
          type: Wechat.Type.WEBPAGE,
          webpageUrl: API_ENDPOINT.H5_URL + '#/'
        }
      },
      scene: scene
    }, function() {
      $timeout(function() {
        window.plugins.toast.showShortCenter(
          "分享成功~",
          function(a) {},
          function(b) {}
        );
      }, 1500);
    }, function(error) {
    });
  }
})
